SystemOrganization addCategory: #'Sight-OB-Cst'!
SystemOrganization addCategory: #'Sight-OB-Path'!

OBCommand subclass: #SCmdShowTestResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-OB-Cst'!

!SCmdShowTestResult methodsFor: 'user interface' stamp: 'rkrk 12/8/2009 13:51'!
addItemToMenu: aMenu

	"don't add to menu'"! !

!SCmdShowTestResult methodsFor: 'data' stamp: 'bs 1/14/2010 12:53'!
allTestsPassed

	^ self testResult hasPassed! !

!SCmdShowTestResult methodsFor: 'accessing' stamp: 'rkrk 9/30/2009 01:56'!
browser

	^ requestor browser! !

!SCmdShowTestResult methodsFor: 'icon assembly' stamp: 'bs 1/14/2010 11:14'!
buttonLabelWithSpaces

	| fillColor frame canvas |
	fillColor := self allTestsPassed
		ifTrue: [Color green]
		ifFalse: [Color red].
	frame := 0@0 corner: 60@25.
	canvas := self canvasFits: frame colored: fillColor.
	self isRunning ifTrue: [
		self
			drawHourglassOn: canvas
			colored: fillColor
			at: 10@5].
	self defectCount isZero ifFalse: [
		self
			drawString: self defectCount asString
			on: canvas
			fitting: (30@5 corner: 55@20)].
	^ canvas form asMorph.! !

!SCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 9/30/2009 05:27'!
canvasFits: frame colored: fillColor

	| canvas rounding roundingLeft roundingRight |
	canvas :=(FormCanvas extent: frame extent depth: 16) asAlphaBlendingCanvas: 1.
	
	rounding := 20.
	roundingLeft := frame topLeft corner: (frame right-rounding)@frame bottom.
	canvas fillOval: roundingLeft color: fillColor.
	roundingRight := (frame left+rounding)@frame top corner: frame bottomRight.
	canvas fillOval: roundingRight color: fillColor.
	canvas
		fillRectangle: (roundingRight topLeft corner: roundingLeft bottomRight)
		color: fillColor.

	^ canvas.! !

!SCmdShowTestResult methodsFor: 'data' stamp: 'bs 1/14/2010 11:06'!
csInfo
	^ self browser csInfo! !

!SCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 9/30/2009 02:33'!
defectCount

	^ self testResult failureCount + self testResult errorCount! !

!SCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 9/30/2009 05:28'!
drawHourglassOn: canvas colored: fillColor at: pt

	| hourglass |
	hourglass := MenuIcons csHourGlassIcon deepCopy
		mapColor: Color white
		to: fillColor.
	canvas translucentImage: hourglass at: pt.! !

!SCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 9/30/2009 04:37'!
drawString: string on: canvas fitting: rect

	canvas drawString: string in: rect.! !

!SCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 10/7/2009 11:15'!
dummyLabelGreen: isGreen running: isRunning defectCount: defects

	| fillColor frame canvas |
	fillColor := isGreen
		ifTrue: [Color green]
		ifFalse: [Color red].
	frame := 0@0 corner: 60@25.
	canvas := self canvasFits: frame colored: fillColor.
	isRunning ifTrue: [
		self
			drawHourglassOn: canvas
			colored: fillColor
			at: 10@5].
	defects isZero ifFalse: [
		self
			drawString: defects asString
			on: canvas
			fitting: (30@5 corner: 55@20)].
	^ canvas form asMorph.! !

!SCmdShowTestResult methodsFor: 'execution' stamp: 'bs 1/14/2010 11:18'!
execute

	self csInfo openTestRunner! !

!SCmdShowTestResult methodsFor: 'accessing' stamp: 'rkrk 9/22/2009 02:20'!
group
	^ #codesight! !

!SCmdShowTestResult methodsFor: 'testing' stamp: 'bs 1/14/2010 11:09'!
isActive
	^ self csInfo isActive! !

!SCmdShowTestResult methodsFor: 'data' stamp: 'bs 1/14/2010 11:11'!
isRunning

	^ self csInfo isRunning! !

!SCmdShowTestResult methodsFor: 'accessing' stamp: 'rkrk 12/8/2009 13:52'!
label

	^ 'this should not appear anywhere'! !

!SCmdShowTestResult methodsFor: 'data' stamp: 'bs 1/14/2010 11:15'!
testResult

	^ self csInfo testResult! !

!SCmdShowTestResult methodsFor: 'testing' stamp: 'rkrk 9/22/2009 02:19'!
wantsButton

	^ true
! !

OBCommand subclass: #SObCmdBrowseBehavior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-OB-Path'!

!SObCmdBrowseBehavior methodsFor: 'execution' stamp: 'bs 7/17/2010 12:45:59.357'!
execute
	| testReference tracer targetMethod targetReference |
	targetMethod := target theClass >> target selector.
	targetReference := targetMethod methodReference.
	
	testReference := 
		targetMethod hasCoveringTestMethods
			ifTrue: [ targetMethod coveringTestMethods anyOne methodReference ]
			ifFalse: [ 
				(UserDialogBoxMorph confirm: 'No coverage information available. Trace all project tests?' )
					ifTrue: [
						tracer := STestCoverageTracer on: SProject current categories.
						(tracer getAllCoveredTestsFor: targetReference) anyOne ]
					ifFalse: [
						nil ] ].
	
	^ testReference ifNotNil: [
		SPathFinder 
			openOn: testReference 
			and: targetReference ] ! !

!SObCmdBrowseBehavior methodsFor: 'accessing' stamp: 'bs 7/4/2010 14:44:37.511'!
group

	^ #codesight! !

!SObCmdBrowseBehavior methodsFor: 'testing' stamp: 'bs 7/5/2010 20:31:58.087'!
isActive

	^ target isMethodNode 
		and: [ SInfo instance isClassManaged: target theClass ]! !

!SObCmdBrowseBehavior methodsFor: 'accessing' stamp: 'bs 7/4/2010 14:43:22.337'!
label

	^ 'browse behavior'! !

!SObCmdBrowseBehavior methodsFor: 'testing' stamp: 'bs 7/4/2010 13:46:00.95'!
wantsButton

	^ false! !

OBTextMorphWithShout subclass: #STextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-OB-Cst'!

!STextMorph methodsFor: 'private' stamp: 'bs 7/4/2010 12:48:34.776'!
paragraphClass
	^ SParagraph! !

!OBCodeBrowser methodsFor: '*Sight-OB' stamp: 'bs 7/17/2010 13:02:48.057'!
cmdBrowseBehavior
	^ SObCmdBrowseBehavior! !

!OBPluggableTextMorphWithShout methodsFor: '*Sight-OB-override' stamp: 'bs 7/4/2010 12:48:55.071'!
textMorphClass
	^ STextMorph! !

!OBClassAwareNode methodsFor: '*Sight-OB' stamp: 'bs 7/4/2010 12:48:24.627'!
csInfo
	^ SInfo instance! !

OBClassAwareNode subclass: #OBCoveringTestCaseBaseNode
	instanceVariableNames: 'coveredMethodNode definition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-OB-Cst'!

!OBCoveringTestCaseBaseNode methodsFor: 'accessing' stamp: 'test 9/22/2009 16:38'!
coveredMethod
	^ coveredMethodNode compiledMethod! !

!OBCoveringTestCaseBaseNode methodsFor: 'accessing' stamp: 'test 9/22/2009 16:38'!
coveredMethodNode
	^ coveredMethodNode ! !

!OBCoveringTestCaseBaseNode methodsFor: 'accessing' stamp: 'test 9/22/2009 16:37'!
coveredMethodNode: anObject
	coveredMethodNode := anObject.
	definition := coveredMethodNode definition.! !

!OBCoveringTestCaseBaseNode methodsFor: 'accessing' stamp: 'test 9/22/2009 16:38'!
definition
	^ definition! !

OBCoveringTestCaseBaseNode subclass: #OBCoveringTestCaseNode
	instanceVariableNames: 'testMethod statistics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-OB-Cst'!

!OBCoveringTestCaseNode class methodsFor: 'as yet unclassified' stamp: 'bs 1/3/2010 22:37'!
on: testMethod coveredMethodNode: aCoveredMethodNode
	^ self new 
		testMethod: testMethod;
		coveredMethodNode: aCoveredMethodNode.! !

!OBCoveringTestCaseNode methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2010 18:19:02.992'!
name
	^ self testMethod selector asString, ': ', self testMethod methodClass name! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 20:53'!
testMethod
	^ testMethod! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 20:53'!
testMethod: anObject
	testMethod := anObject! !

OBCoveringTestCaseBaseNode subclass: #OBCoveringTestCaseSeparatorNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-OB-Cst'!

!OBCoveringTestCaseSeparatorNode class methodsFor: 'as yet unclassified' stamp: 'test 9/22/2009 16:36'!
coveredMethodNode: aCoveredMethodNode
	^ self new 
		coveredMethodNode: aCoveredMethodNode.! !

!OBCoveringTestCaseSeparatorNode methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2010 10:53:59.812'!
name
	| nFixedTests nCoveringTests | 
	nFixedTests := self coveredMethod fixedTestMethods size.
	nCoveringTests := self coveredMethod coveringTestMethods size.
	^ ('---', nFixedTests asString, '/', nCoveringTests asString, '---', String crlf, '---') asText! !

!OBPluggableListMorph methodsFor: '*Sight-OB' stamp: 'mt 3/18/2010 19:04'!
backgroundColorAt: anInteger

    ^ model backgroundColorAt: anInteger! !

!OBNode methodsFor: '*Sight-OB' stamp: 'mt 3/18/2010 19:11'!
backgroundColor

	^ nil! !

!OBMethodNode methodsFor: '*Sight-OB' stamp: 'bs 1/14/2010 14:49'!
backgroundColor

	((self csInfo isClassManaged: theClass) not
		or: [selector isTestSelector]
		or: [(theClass includesSelector: selector) not]
		or: [(theClass compiledMethodAt: selector) hasCoveringTestMethods])
			ifTrue: [^ super backgroundColor].
	^ Color lightOrange.! !

!OBMethodNode methodsFor: '*Sight-OB' stamp: 'bs 5/4/2009 21:53'!
compiledMethod
	^ theClass compiledMethodAt: self selector! !

!OBMethodNode methodsFor: '*Sight-OB' stamp: 'bs 8/17/2010 11:02:36.984'!
coveringTestMethods

	| testMethodNodes theMethod node createAndAddCoveringNode |
	testMethodNodes := OrderedCollection new.
	(theClass includesSelector: selector) ifTrue: [
		theMethod := self compiledMethod.
		createAndAddCoveringNode := [:testMethod | 
			node := OBCoveringTestCaseNode on: testMethod 
							coveredMethodNode: self.
			testMethodNodes add: node ].
		
		theMethod fixedTestMethods do: createAndAddCoveringNode.
		
		node := OBCoveringTestCaseSeparatorNode coveredMethodNode: self.
		testMethodNodes add: node.
		
		"theMethod coveringAndNotFixedTestMethods do: createAndAddCoveringNode" ].
	
	^ testMethodNodes.! !

!OBLazyListMorph methodsFor: '*Sight-OB-override' stamp: 'bs 10/22/2010 16:01:54.095'!
display: item atRow: row on: canvas 
	"Display the given item at row row."
	
	| drawBounds top icon |
	drawBounds := self drawBoundsForRow: row.
	drawBounds := drawBounds intersect: self bounds.
	
	(listSource backgroundColorAt: row) ifNotNilDo: [:aColor | canvas fillRectangle: drawBounds color: aColor].
	
	(listSource iconAt: row) ifNotNil: [ :name | 
		icon := OBMorphicIcons iconNamed: name.
		top := drawBounds top + ((drawBounds height - icon height) // 2).
		canvas 
			translucentImage: icon
			at: drawBounds left @ top.
		drawBounds := drawBounds left: drawBounds left + icon width + 2 ].
	item isText 
		ifTrue: [ 
			canvas 
				drawString: item string
				in: drawBounds
				font: (font emphasized: (item emphasisAt: 1))
				color: (item colorAt: 1) ]
		ifFalse: [
			canvas 
				drawString: item
				in: drawBounds
				font: font
				color: (self colorForRow: row) ]! !

!OBMorphicIcons methodsFor: '*Sight-OB' stamp: 'mt 5/3/2009 20:44'!
csAccept

	^ MenuIcons csAcceptIcon! !

!OBMethodCategoryNode methodsFor: '*Sight-OB' stamp: 'bs 1/14/2010 14:49'!
backgroundColor
	| methodSelectors methodsToBeChecked |
	
	(self csInfo isClassManaged: theClass)
		ifTrue: [
			methodSelectors := (name = ClassOrganizer allCategory)
				ifTrue: [theClass organization allMethodSelectors]
				ifFalse: [theClass organization listAtCategoryNamed: name].
			
			methodsToBeChecked := methodSelectors select: [:aSelector | aSelector isTestSelector not ] 
														 	  thenCollect: [:aSelector | theClass compiledMethodAt: aSelector].
				
			(methodsToBeChecked allSatisfy: [:aMethod | aMethod hasCoveringTestMethods])
				ifFalse: [^ Color lightOrange]].
	
	^ super backgroundColor! !

!OBList methodsFor: '*Sight-OB' stamp: 'mt 3/18/2010 19:08'!
backgroundColorAt: anInteger

	^ self fan backgroundColorAt: anInteger! !

!OBClassNode methodsFor: '*Sight-OB' stamp: 'bs 1/14/2010 14:49'!
backgroundColor

	(self csInfo isClassManaged: theClass)
		ifFalse: [^ super backgroundColor].
	theClass methodDict values do: [:method |
		(method hasCoveringTestMethods
			or: [method selector isTestSelector
				and: [theClass inheritsFrom: TestCase]])
					ifFalse: [^ Color lightOrange]].
	^ super backgroundColor.! !

!OBFan methodsFor: '*Sight-OB' stamp: 'mt 3/18/2010 19:07'!
backgroundColorAt: anInteger

	^ (self children at: anInteger ifAbsent: [^nil]) backgroundColor! !

TestCase subclass: #SObBrowseBehaviorTest
	instanceVariableNames: 'oldCurrentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-OB-Path'!

!SObBrowseBehaviorTest methodsFor: 'as yet unclassified' stamp: 'bs 7/17/2010 12:47:20.995'!
exampleMethod
	^ SSBClassA >> #doNothing! !

!SObBrowseBehaviorTest methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 19:07:03.501'!
exampleMethodReference
	^ self exampleMethod methodReference! !

!SObBrowseBehaviorTest methodsFor: 'as yet unclassified' stamp: 'bs 7/17/2010 12:47:28.844'!
exampleTestMethod
	^ SSBTest >> #testDoNothing! !

!SObBrowseBehaviorTest methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 19:05:58.342'!
openBrowserOn: aCompiledMethod
	^ self 
		openBrowserOnClass: aCompiledMethod methodClass 
		selector: aCompiledMethod selector! !

!SObBrowseBehaviorTest methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 13:52:58.693'!
openBrowserOnClass: aClass selector: aSelector
	
	| brow classToUse |
	classToUse := OBSystemBrowserAdaptor.
	brow := classToUse new.
	brow setClass: aClass selector: aSelector.
	^ (classToUse 
		openBrowserView: (brow openEditString: nil)
		label: brow labelString)
			model! !

!SObBrowseBehaviorTest methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 12:02:37.666'!
setUp

	oldCurrentProject := SProject current.
	SProject setCurrentProject: SProject sandboxProject.
	
	self exampleMethod 
		resetAllCoverageData;
		methodExtension: SNonTestMethodExtension new.
	self exampleMethod cstMethodExtension clientMethod: self exampleMethod.
		
	self exampleTestMethod 
		resetAllCoverageData;
		methodExtension: STestMethodExtension new.
	self exampleTestMethod cstMethodExtension clientMethod: self exampleTestMethod.
	
	self exampleMethod cstMethodExtension 
			calledBy: self exampleTestMethod 
			receiverClass: self exampleMethod methodClass.! !

!SObBrowseBehaviorTest methodsFor: 'as yet unclassified' stamp: 'bs 7/17/2010 13:02:05.607'!
tearDown

	SProject setCurrentProject: oldCurrentProject.
	self exampleMethod resetMethodExtension.
	super tearDown.! !

!SObBrowseBehaviorTest methodsFor: 'as yet unclassified' stamp: 'bs 7/17/2010 13:02:48.06'!
testBrowseBehavior
	| browser methodNode command testExpander selectedItem |
	
	self assert: (OBCodeBrowser canUnderstand: #cmdBrowseBehavior).
	browser := self openBrowserOn: self exampleMethod.
	methodNode := (OBMethodNode on: self exampleMethodReference).
	command := SObCmdBrowseBehavior on: methodNode for: self.
	testExpander := command execute.
	
	selectedItem := testExpander callgraphModel selectedItem.
	self assert: selectedItem clientClass = self exampleMethod methodClass.
	self assert: selectedItem clientSelector = self exampleMethod selector.
	
	browser dependents first abandon.
	testExpander windowMorph abandon.! !

MultiNewParagraph subclass: #SParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-OB-Cst'!

!SParagraph methodsFor: 'fonts-display' stamp: 'bs 12/21/2009 16:48'!
displayOn: aCanvas using: displayScanner at: somePosition
	"Send all visible lines to the displayScanner for display"
	
	| visibleRectangle line |
	visibleRectangle := aCanvas clipRect.
	(self lineIndexForPoint: visibleRectangle topLeft)
		to: (self lineIndexForPoint: visibleRectangle bottomRight)
		do: [:i | line := lines at: i.
			self drawBackgroundEmphasisInLine: line on: aCanvas ].
	
	super displayOn: aCanvas using: displayScanner at: somePosition.
! !

!SParagraph methodsFor: 'fonts-display' stamp: 'bs 12/21/2009 17:01'!
drawBackgroundEmphasisInLine: line on: aCanvas
	| textLine |
	textLine := self text
		copyFrom: line first
		to: line last.
	textLine runs withStartStopAndValueDo: [:start :stop :attributes | 
		attributes do: [:anAttr | | cb1 cb2 bounds |
			cb1 := self characterBlockForIndex: start + (line first - 1).
			cb2 := self characterBlockForIndex: stop + (line first - 1). 
			bounds := cb1 left @ line top corner: cb2 right @ line bottom.
			anAttr emphasizeBackground: bounds on: aCanvas ] ]! !

!OBColumn methodsFor: '*Sight-OB' stamp: 'mt 3/18/2010 19:08'!
backgroundColorAt: anInteger

    ^ self listHolder backgroundColorAt: anInteger! !
